import cmdlib, effectlib, es, keyvalues, langlib, os.path, playerlib, popuplib, services, cfglib , gamethread, vecmath

info = es.AddonInfo()
info.name = 'Anti Rush'
info.version = '1.1'
info.author = 'AbSoLuTe'
info.basename = 'anti_rush'
info.url = "http://addons.eventscripts.com/addons/view/%s"%info.basename
info.description = "Stops people from rushing by slaying or kicking them" 


es.ServerVar(info.basename, info.version, info.description + " made by " + info.author).makepublic()

config = cfglib.AddonCFG( os.path.join( es.getAddonPath(info.basename), "config.cfg" ) )
config.text("../addons/eventscripts/%s/config.cfg" % info.basename )
config.text("%s Version %s by %s" % ( info.name, info.version, info.author ) )
config.text("For more info, visit: %s" % info.url)
config.text("********************************************************************")
config.text("SETUP")
config.text("********************************************************************")
norushtime = config.cvar("norushtime", 0, "Time till rushing is allowed (0 means never)")
rushevent = config.cvar("rushevent", 1, "Rushing will be allowed on Bomb defuse or Hostage rescue")
checktime = config.cvar("checktime", 0.5, "The time between each position check")
last_man_rushing = config.cvar("last_man_rushing", 0, "If there is only <num> players of one team left, then the other team will be allowed to rush ( 0 means disabled )")
rush_punishment = config.cvar("rush_punishment", 4, "The punish method (0 = let them only use their knife whilst in the region if they dont slay them,1 = slay, 2 = kick, 3 = ban)")
bantime = config.cvar("bantime", 10, "Time the rusher gets banned , if used (0 means permanent!)")
admin_immunity = config.cvar("admin_immunity", 0, "If authed admins should be immune to the rush punishment")
beam = config.cvar("beam", 1, "If there should be a beam, which shows the region")
config.text("Following are the colors of the Beam for the Ts")
t_red_amount = config.cvar("t_red_amount", 255)
t_green_amount = config.cvar("t_green_amount", 0)
t_blue_amount = config.cvar("t_blue_amount", 0)
config.text("Following are the colors of the Beam for the CTs")
ct_red_amount = config.cvar("ct_red_amount", 0)
ct_green_amount = config.cvar("ct_green_amount", 0)
ct_blue_amount = config.cvar("ct_blue_amount", 255)
anti_rush_debug = config.cvar("anti_rush_debug", 0)



config.write()
config.execute()

auth = services.use('auth')
popuplist = ['active_zones', 'change_zone', 'manage_zone', 'zones_popup', 'change_fence']
text = None
tokens = {}
zonelist = ['zone_1', 'zone_2', 'zone_3', 'zone_4', 'zone_5', 'zone_6', 'zone_7', 'zone_8', 'zone_9', 'zone_10']
t_message_told = False
ct_message_told = False

langPath = os.path.join( es.getAddonPath( info.basename ), "strings.ini" )
if os.path.isfile(langPath):
    text = langlib.Strings(langPath)

def load():
    auth.registerCapability('anti_rush_admin', auth.ADMIN)
    cmdlib.registerSayCommand('!zones', ar.zonescmd, 'zonescmd', 'anti_rush_admin', 'ADMIN')
    es.server.queuecmd("mp_restartgame 1")
    if not rush_punishment:
        es.doblock("corelib/noisy_on")
    
def unload():
    cmdlib.unregisterSayCommand('!zones')
    zm.resetZones()
    if es.exists('keygroup', 'zones', '|anti_rush'):
        es.keygroupdelete('zones')
    for popup in popuplist:
        if popuplib.exists(popup):
            popuplib.delete(str(popup))
            
def round_freeze_end(event_var):
    global ar
    global t_message_told, ct_message_told
    t_message_told = False
    ct_message_told = False
    zm.resetZones()
    ar.newround()
    zm.checkZone()
      
def player_death(event_var):
    if last_man_rushing:
        if es.getlivingplayercount(event_var["es_userteam"]) <= last_man_rushing:
            global t_message_told, ct_message_told
            if int(event_var["es_userteam"]) == 2:
                if not t_message_told:  
                    es.msg('#multi', text('last man rushing t'))
                t_message_told = True
                
                
            else:
                if not ct_message_told:  
                    es.msg('#multi', text('last man rushing ct'))
                ct_message_told = True
            zm.delTeamZones(5-int(event_var["es_userteam"]))
            gamethread.cancelDelayed('allowrush')

def weapon_fire(event_var):
    userid = int(event_var["userid"])
    weapon = event_var['weapon']
    zm.checkWeaponFire(userid,weapon)
           
def bomb_planted(event_var):
    if rushevent:
        global t_message_told
        if not t_message_told: 
            zm.resetZones()
            es.msg('#multi', text('bomb planted'))
            t_message_told = True
        
        gamethread.cancelDelayed('allowrush')

def hostage_follows(event_var):
    if rushevent:
        global t_message_told
        if not t_message_told:
            zm.resetZones()
            es.msg('#multi', text('hostage follows'))
            gamethread.cancelDelayed('allowrush')
            t_message_told = True

def round_end(event_var):
    zm.resetZones()
    gamethread.cancelDelayed('allowrush')
    
    
    
def bullet_impact(event_var):
    """ A little bug is, that if you shoot at a corner of a crate for example and it shoots through, then it will take these two points as region """
    userid = int(event_var['userid'])
    if auth.isUseridAuthorized(userid, 'anti_rush_admin'):
        ar.bulletImpact(float(event_var['x']),float(event_var['y']),float(event_var['z']),userid)

def allowrush():
    zm.resetZones()
    if not t_message_told or not ct_message_told:
        global t_message_told, ct_message_told
        t_message_told = True
        ct_message_told = True
        debugCommand("allowed rush")
        es.msg('#multi', text('rush allowed'))
        
def drawBoxTeam(coord1,coord2,team):
    if team == 2:
        R = t_red_amount
        G = t_green_amount
        B = t_blue_amount
    else:
        R = ct_red_amount
        G = ct_green_amount
        B = ct_blue_amount
    effectlib.drawBox(coord1,coord2,seconds=5,red=R,blue=B,green=G)
        
def drawFence(coord1,coord2,team,style):
    if float(coord1[2]) > float(coord2[2]):
        drawFence(coord2,coord1,team,style)
        return
    cd1 = es.createvectorstring(coord1[0],coord1[1],int(coord1[2])+24)
    cd2 = es.createvectorstring(coord2[0],coord1[1],int(coord1[2])+24)
    cd3 = es.createvectorstring(coord2[0],coord2[1],int(coord1[2])+24)
    cd4 = es.createvectorstring(coord1[0],coord2[1],int(coord1[2])+24)
    
    if team == 2:
        R = t_red_amount
        G = t_green_amount
        B = t_blue_amount
    else:
        R = ct_red_amount
        G = ct_green_amount
        B = ct_blue_amount
    if 1 & style:
        effectlib.drawLine(cd1,cd2,seconds=checktime,red=R,blue=B,green=G)
    if 2 & style:
        effectlib.drawLine(cd2,cd3,seconds=checktime,red=R,blue=B,green=G)
    if 4 & style:
        effectlib.drawLine(cd3,cd4,seconds=checktime,red=R,blue=B,green=G)
    if 8 & style:
        effectlib.drawLine(cd4,cd1,seconds=checktime,red=R,blue=B,green=G)
   
def debugCommand(string):
    if anti_rush_debug:
        es.log(string)
   
class ZoneManager(object):
    def __init__(self):
        self.zonecoords = {}
        self.names = 0
    def addZone(self,team,coord1,coord2,style):
        self.names += 1
        self.zonecoords["zone_%02i"% self.names] = [team,coord1,coord2,style]
        
    def resetZones(self):
        debugCommand("resetZones")
        self.zonecoords = {}
        self.names = 0
        gamethread.cancelDelayed('zonecheck')
        
    def delTeamZones(self,team):
        debugCommand("delTeamZones %s"%team)
        dellist = []
        for zone in self.zonecoords:
            if self.zonecoords[zone][0] == team:
                dellist.append(zone)
        for zone in dellist:
            del self.zonecoords[zone]
        
    def checkZone(self):
        for zone in self.zonecoords:
            if es.getlivingplayercount(5-self.zonecoords[zone][0]) <= last_man_rushing:
                continue
            drawFence(self.zonecoords[zone][1],self.zonecoords[zone][2],self.zonecoords[zone][0],self.zonecoords[zone][3])
        if not rush_punishment:
            gamethread.delayedname(checktime,'zonecheck',self.checkZone)
            return
        for userid in es.getUseridList():
            if not es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
                if es.getlivingplayercount(5-es.getplayerteam(userid)) <= last_man_rushing:
                    continue
                for zone in self.zonecoords:
                    tempz1 = self.zonecoords[zone][1]
                    tempz2 = self.zonecoords[zone][2]
                    if vecmath.isbetweenRect(es.getplayerlocation(userid), (float(tempz1[0]),float(tempz1[1]),float(tempz1[2])),(float(tempz2[0]),float(tempz2[1]),float(tempz2[2])) ):
                        
                        if es.getplayerteam(userid) == self.zonecoords[zone][0]:
                            debugCommand("%s is in rect %s , %s and is in the right team" % (userid,tempz1,tempz2))

                            if admin_immunity and auth.isUseridAuthorized(userid, 'anti_rush_admin'):
                                es.tell(userid, '#multi', text('rush', lang=playerlib.getPlayer(userid).get('lang')))
                            
                            else:

                                tokens = {}
                                tokens['name'] = es.getplayername(userid)
                                if rush_punishment == 1:
                                    es.server.queuecmd("es_xsexec %s kill" % userid)
                                    es.msg('#multi', text('slayed', tokens))
                                elif rush_punishment == 2:
                                    reason = text('reason', lang=playerlib.getPlayer(userid).get('lang'))
                                    es.server.queuecmd('kickid %s %s' %(userid, reason))
                                    es.msg('#multi', text('kicked', tokens))
                                elif rush_punishment == 3:
                                    es.server.queuecmd('banid %s %s kick' %(bantime, userid))
                                    es.msg('#multi', text('banned', tokens))
                                elif rush_punishment == 4:
                                    debugCommand("rush_punishment 4")
                                    weapon = playerlib.getPlayer(userid).weapon
                                    if weapon != "weapon_knife":
                                        debugCommand("%s rushed with %s"%(userid,weapon))
                                        es.server.queuecmd("es_xsexec %s kill" % userid)
                                        tokens = {}
                                        tokens['name'] = es.getplayername(userid)
                                        es.msg('#multi', text('slayedknife', tokens))
                                        
        gamethread.delayedname(checktime,'zonecheck',self.checkZone)
        
    def checkWeaponFire(self,userid,weapon):
        if rush_punishment:
            return
        if weapon != "knife":
            for zone in self.zonecoords:
                if es.getplayerteam(userid) != self.zonecoords[zone][0]:
                    continue
                tempz1 = self.zonecoords[zone][1]
                tempz2 = self.zonecoords[zone][2]
                if vecmath.isbetweenRect(es.getplayerlocation(userid), (float(tempz1[0]),float(tempz1[1]),float(tempz1[2])),(float(tempz2[0]),float(tempz2[1]),float(tempz2[2])) ):
                    debugCommand("%s fired a weapon in %s , %s" % (userid,tempz1,tempz2))
                    tokens = {}
                    tokens['name'] = es.getplayername(userid)
                    # es.sexec(userid,"kill")
                    es.server.queuecmd("es_xsexec %s kill" % userid)
                    es.msg('#multi', text('slayedknife', tokens))
            
zm = ZoneManager()
        
class AntiRush(object):
    def __init__(self):
        self.active_zones = None
        self.change_zone = None
        self.manage_zone = None
        self.zones = None
        self.zones_popup = None
        self.change_fence = None
        self.temp_x = 0
        self.temp_y = 0
        self.temp_z = 0
        self.temp_coord = 0
        self.temp_team = 0
        self.shot = 22
        self.temp_x1 = 0
        self.temp_y1 = 0
        self.temp_z1 = 0
        self.newround()
        
    def newround(self):
        self.current_map = str(es.server_var['eventscripts_currentmap'])
        
        if es.exists('keygroup', 'zones', '|anti_rush'):
            es.keygroupdelete('zones', '|anti_rush')
        es.keygroupload('zones', '|anti_rush')
        self.zones = keyvalues.getKeyGroup('zones')
        if es.exists('key', self.zones, self.current_map):

            if norushtime:
                tokens['norushtime'] = str(norushtime)
                es.msg('#multi', text('announcement',tokens))
                gamethread.cancelDelayed('allowrush')
                gamethread.delayedname(norushtime,'allowrush',allowrush)
            else:
                es.msg('#multi',text("announcement1"))
        else:
            global t_message_told, ct_message_told
            t_message_told = True
            ct_message_told = True
        
        for zone in zonelist:
            if es.exists('keyvalue', self.zones, self.current_map, zone):
                
                splittedv1 = str(self.zones[self.current_map]['%s_v1' %zone]).split(",")
                splittedv2 = str(self.zones[self.current_map]['%s_v2' %zone]).split(",")
                
                if not es.exists('keyvalue', self.zones, self.current_map, zone + "_team"):
                    if self.current_map.startswith("cs_"):
                        self.zones[self.current_map]['%s_team' %zone] = 3
                    else:
                        self.zones[self.current_map]['%s_team' %zone] = 2
                zm.addZone( int(self.zones[self.current_map]['%s_team' %zone]) , (splittedv1[0],splittedv1[1],splittedv1[2]),(splittedv2[0],splittedv2[1],splittedv2[2]),int(self.zones[self.current_map][zone]) )
        
        
    def zonescmd(self,userid, args):
        self.zones_popup = popuplib.create('zones_popup')
        self.zones_popup.addline('%s: %s' %(text('map'), self.current_map))
        self.zones_popup.addline('->1. %s' %text('active zones'))
        self.zones_popup.addline('->2. %s' %text('add zone'))
        # self.zones_popup.addline('->3. %s' %text('draw zones'))
        self.zones_popup.addline('->0. %s' %text('close'))
        self.zones_popup.menuselect = self.zonespopup
        self.zones_popup.send(userid)
    
    def addingzone(self,userid, choice, popupname):
        if choice == 1:
            drawBoxTeam(self.temp_corner1,self.temp_corner2,2)
            self.adding_zone_popup.send(userid)
        elif choice == 2:
            number = 0
            for zone in zonelist:
                if es.exists('keyvalue', self.zones, self.current_map, zone):
                    number = number + int(1)
            if not es.exists('key', self.zones, self.current_map):
                self.zones[self.current_map] = keyvalues.KeyValues(name=self.current_map)
            number = number + int(1)
            self.zones[self.current_map]['zone_%i' %number] = 15
            self.zones[self.current_map]['zone_%i_v1' %number] = self.temp_corner1
            self.zones[self.current_map]['zone_%i_v2' %number] = self.temp_corner2
            self.zones[self.current_map]['zone_%i_team' %number] = 2
            es.keygroupsave('zones', '|anti_rush')
        elif choice == 10:
            popuplib.close('adding_zone_popup', userid)
            
    def changezone(self,userid, choice, popupname):
        global temp_x, temp_y, temp_z
        if choice == 1:
            self.temp_x = self.temp_x + 5
        elif choice == 2:
            self.temp_y = self.temp_y + 5
        elif choice == 3:
            self.temp_z = self.temp_z + 5
        elif choice == 4:
            self.temp_x = self.temp_x - 5
        elif choice == 5:
            self.temp_y = self.temp_y - 5
        elif choice == 6:
            self.temp_z = self.temp_z - 5
        elif choice == 8:
            self.zones[self.current_map][self.temp_zone] = "%i,%i,%i" % (self.temp_x, self.temp_y, self.temp_z)
            es.keygroupsave('zones', '|anti_rush')
        elif choice == 10:
            popuplib.close('change_zone', userid)
        if choice < 8:
            drawBoxTeam(es.createvectorstring(self.temp_x, self.temp_y, self.temp_z),self.temp_coord,self.temp_team)
        if choice < 9:
            self.change_zone.send(userid)
            
    def activezones(self,userid, choice, popupname):
        self.temp_zone = choice
        self.manage_zone = popuplib.create('manage_zone')
        self.manage_zone.addline('%s: %s' %(text('manage zone'), self.temp_zone))
        self.manage_zone.addline('->1. %s' %text('show zone'))
        self.manage_zone.addline('->2. %s' %('%s_v1' %self.temp_zone))
        self.manage_zone.addline('->3. %s' %('%s_v2' %self.temp_zone))
        if not es.exists('keyvalue', self.zones, self.current_map, self.temp_zone + "_team"):
            if self.current_map.startswith("cs_"):
                self.zones[self.current_map]['%s_team' %self.temp_zone] = 3
            else:
                self.zones[self.current_map]['%s_team' %self.temp_zone] = 2
        if self.zones[self.current_map]['%s_team' % self.temp_zone] == 2: 
            team = "Terrorists" 
        else: 
            team = "Counter-Terrorist"
        self.manage_zone.addline('->4. %s' %text('change team',{"team":team}))
        self.manage_zone.addline('->5. %s' %text('fences'))
        # self.manage_zone.addline('->6. %s' %text('delete zone'))
        self.manage_zone.addline('->9. %s' %text('back'))
        self.manage_zone.addline('->0. %s' %text('close'))
        self.manage_zone.menuselect = self.managezone
        self.manage_zone.send(userid)

    def managezone(self,userid, choice, popupname):
        if choice == 1:
            self.temp_zone_v1 = self.zones[self.current_map]['%s_v1' %self.temp_zone]
            self.temp_zone_v2 = self.zones[self.current_map]['%s_v2' %self.temp_zone]
            drawBoxTeam(self.temp_zone_v1,self.temp_zone_v2,self.zones[self.current_map]['%s_team' % self.temp_zone])
            self.manage_zone.send(userid)
        elif choice == 2:
            self.temp_team = self.zones[self.current_map]['%s_team' %self.temp_zone]
            (self.temp_x, self.temp_y, self.temp_z) = es.splitvectorstring(self.zones[self.current_map]['%s_v1' %self.temp_zone])
            self.change_zone = popuplib.create('change_zone')
            self.change_zone.addline('%s: %s_v1' %(text('coordinate'), self.temp_zone))
            self.temp_coord = self.zones[self.current_map]['%s_v2' %self.temp_zone]
            self.temp_zone = '%s_v1' %self.temp_zone
        elif choice == 3:
            self.temp_team = self.zones[self.current_map]['%s_team' %self.temp_zone]
            (self.temp_x, self.temp_y, self.temp_z) = es.splitvectorstring(self.zones[self.current_map]['%s_v2' %self.temp_zone])
            self.change_zone = popuplib.create('change_zone')
            self.change_zone.addline('%s: %s_v2' %(text('coordinate'),self.temp_zone))
            self.temp_coord = self.zones[self.current_map]['%s_v1' %self.temp_zone]
            self.temp_zone = '%s_v2' %self.temp_zone
        elif choice == 4:
            self.zones[self.current_map][self.temp_zone + "_team"] = 5 - self.zones[self.current_map][self.temp_zone + "_team"]
            drawBoxTeam(self.zones[self.current_map][self.temp_zone + "_v1"],self.zones[self.current_map][self.temp_zone + "_v2"],self.zones[self.current_map][self.temp_zone + "_team"])
            es.keygroupsave('zones', '|anti_rush')
            self.manage_zone = popuplib.create('manage_zone')
            self.manage_zone.addline('%s: %s' %(text('manage zone'), self.temp_zone))
            self.manage_zone.addline('->1. %s' %text('show zone'))
            self.manage_zone.addline('->2. %s' %('%s_v1' %self.temp_zone))
            self.manage_zone.addline('->3. %s' %('%s_v2' %self.temp_zone))
            if not es.exists('keyvalue', self.zones, self.current_map, self.temp_zone + "_team"):
                if self.current_map.startswith("cs_"):
                    self.zones[self.current_map]['%s_team' %self.temp_zone] = 3
                else:
                    self.zones[self.current_map]['%s_team' %self.temp_zone] = 2
            if self.zones[self.current_map]['%s_team' % self.temp_zone] == 2: 
                team = "Terrorists" 
            else: 
                team = "Counter-Terrorist"
            self.manage_zone.addline('->4. %s' %text('change team',{"team":team}))
            self.manage_zone.addline('->5. %s' %text('fences'))
            self.manage_zone.addline('->9. %s' %text('back'))
            self.manage_zone.addline('->0. %s' %text('close'))
            self.manage_zone.menuselect = self.managezone
            self.manage_zone.send(userid)
        elif choice == 6:
            pass
            """
            if es.exists('keyvalue', self.zones, self.current_map, self.temp_zone):
                self.zones[self.current_map][self.temp_zone] = 0
                self.zones[self.current_map]['%s_v1' %self.temp_zone] = 0
                self.zones[self.current_map]['%s_v2' %self.temp_zone] = 0
                self.zones[self.current_map]['%s_team' %self.temp_zone] = 0
                es.keygroupsave('zones', '|anti_rush')
                es.tell(userid,"#multi","%s%s" % (text('deletemessage'), self.temp_zone))
            popuplib.close('manage_zone', userid)
            popuplib.send('active_zones', userid)
            """
        elif choice == 9:
            popuplib.close('manage_zone', userid)
            popuplib.send('active_zones', userid)
        elif choice == 10:
            popuplib.close('manage_zone', userid)
        elif choice == 5:
            self.change_fence = popuplib.create('change_fence')
            self.change_fence.addline('%s: %s' %(text('fences menu'), self.temp_zone))
            status = ["","","",""]
            if 1 & self.zones[self.current_map][self.temp_zone]:
                status[0] = "on"
            else:
                status[0] = "off"
            if 2 & self.zones[self.current_map][self.temp_zone]:
                status[1] = "on"
            else:
                status[1] = "off"
            if 4 & self.zones[self.current_map][self.temp_zone]:
                status[2] = "on"
            else:
                status[2] = "off"
            if 8 & self.zones[self.current_map][self.temp_zone]:
                status[3] = "on"
            else:
                status[3] = "off"
            for x in range(4):
                self.change_fence.addline('->%s. %s %s: %s' %(x+1,text('side'),x+1,status[x]))
            self.change_fence.addline('->8. %s' %text('save changes'))
            self.change_fence.addline('->0. %s' %text('close'))
            self.change_fence.menuselect = self.changefence
            self.change_fence.send(userid)
            
        if choice == 2 or choice == 3:
            self.change_zone.addline('->1. %s X' %text('add to'))
            self.change_zone.addline('->2. %s Y' %text('add to'))
            self.change_zone.addline('->3. %s Z' %text('add to'))
            self.change_zone.addline('->4. %s X' %text('subtract from'))
            self.change_zone.addline('->5. %s Y' %text('subtract from'))
            self.change_zone.addline('->6. %s Z' %text('subtract from'))
            self.change_zone.addline('->7. %s' %text('show zone'))
            self.change_zone.addline('->8. %s' %text('save changes'))
            self.change_zone.addline('->0. %s' %text('close'))
            self.change_zone.menuselect = self.changezone
            self.change_zone.send(userid)
            
    def drawAllZones(self):
        for zone in zonelist:
            if es.exists('keyvalue', self.zones, self.current_map, zone):
                drawBoxTeam(self.zones[self.current_map]['%s_v1' %zone],self.zones[self.current_map]['%s_v1' %zone],self.zones[self.current_map]['%s_team' %zone])
                drawFence(self.zones[self.current_map]['%s_v1' %zone],self.zones[self.current_map]['%s_v2' %zone],self.zones[self.current_map]['%s_team' %zone],self.zones[self.current_map][zone])
                for x in range(4):
                    gamethread.delayed(checktime*(x+1),drawFence,(self.zones[self.current_map]['%s_v1' %zone],self.zones[self.current_map]['%s_v2' %zone],self.zones[self.current_map]['%s_team' %zone],self.zones[self.current_map][zone]))
                
    def changefence(self,userid, choice, popupname):
        if choice == 1:
            if 1 & self.zones[self.current_map][self.temp_zone]:
                self.zones[self.current_map][self.temp_zone] -= 1
            else:
                self.zones[self.current_map][self.temp_zone] += 1
        elif choice == 2:
            if 2 & self.zones[self.current_map][self.temp_zone]:
                self.zones[self.current_map][self.temp_zone] -= 2
            else:
                self.zones[self.current_map][self.temp_zone] += 2
        elif choice == 3:
            if 4 & self.zones[self.current_map][self.temp_zone]:
                self.zones[self.current_map][self.temp_zone] -= 4
            else:
                self.zones[self.current_map][self.temp_zone] += 4
        elif choice == 4:
            if 8 & self.zones[self.current_map][self.temp_zone]:
                self.zones[self.current_map][self.temp_zone] -= 8
            else:
                self.zones[self.current_map][self.temp_zone] += 8
                
        elif choice == 8:
            es.keygroupsave('zones', '|anti_rush')
            self.manage_zone.send(userid)
            
        if choice < 5:
            splittedv1 = self.zones[self.current_map]['%s_v1' %self.temp_zone].split(",")
            splittedv2 = self.zones[self.current_map]['%s_v2' %self.temp_zone].split(",")
            drawFence((splittedv1[0],splittedv1[1],splittedv1[2]),(splittedv2[0],splittedv2[1],splittedv2[2]),self.zones[self.current_map]['%s_team' %self.temp_zone],self.zones[self.current_map][self.temp_zone])
            self.change_fence = popuplib.create('change_fence')
            self.change_fence.addline('%s: %s' %(text('fences menu'), self.temp_zone))
            status = ["","","",""]
            if 1 & self.zones[self.current_map][self.temp_zone]:
                status[0] = "on"
            else:
                status[0] = "off"
            if 2 & self.zones[self.current_map][self.temp_zone]:
                status[1] = "on"
            else:
                status[1] = "off"
            if 4 & self.zones[self.current_map][self.temp_zone]:
                status[2] = "on"
            else:
                status[2] = "off"
            if 8 & self.zones[self.current_map][self.temp_zone]:
                status[3] = "on"
            else:
                status[3] = "off"
            for x in range(4):
                self.change_fence.addline('->%s. %s %s: %s' %(x+1,text('side'),x+1,status[x]))
            self.change_fence.addline('->8. %s' %text('save changes'))
            self.change_fence.addline('->0. %s' %text('close'))
            self.change_fence.menuselect = self.changefence
            self.change_fence.send(userid)
            
    def zonespopup(self, userid, choice, popupname):
        if choice == 1:
            if es.exists('keygroup', 'zones', '|anti_rush'):
                es.keygroupdelete('zones', '|anti_rush')
            es.keygroupload('zones', '|anti_rush')
            self.zones = keyvalues.getKeyGroup('zones')
            self.active_zones = popuplib.easymenu('active_zones', None, self.activezones)
            self.active_zones.settitle('%s:' %text('active zones'))
            for zone in zonelist:
                if es.exists('keyvalue', self.zones, self.current_map, zone):
                    self.active_zones.addoption(zone, zone)
            self.active_zones.submenu(0, 'zones_popup')
            self.active_zones.send(userid)
        elif choice == 2:
            self.shot = 0
            if rush_punishment:
                es.doblock("corelib/noisy_on")
            es.tell(userid, '#multi', text('adding zone instruction', lang=playerlib.getPlayer(userid).get('lang')))
        """
        elif choice == 3:
            self.drawAllZones()
            self.zones_popup.send(userid)
        """
    def bulletImpact(self,x,y,z,userid):
        if self.shot < 2:
            self.shot += 1
            if self.shot == 1:
                self.temp_x1 = x
                self.temp_y1 = y
                self.temp_z1 = z + 1
            elif self.shot == 2:
                
                self.temp_corner1 = "%i,%i,%i" % (self.temp_x1, self.temp_y1, self.temp_z1)
                self.temp_corner2 = "%i,%i,%i" % (x, y, z+1)
                drawBoxTeam(self.temp_corner1,self.temp_corner2,2)
                self.adding_zone_popup = popuplib.create('adding_zone_popup')
                self.adding_zone_popup.addline('%s' %text('adding zone'))
                self.adding_zone_popup.addline('->1. %s' %text('show zone'))
                self.adding_zone_popup.addline('->2. %s' %text('save zone'))
                self.adding_zone_popup.addline('->0.  %s' %text('close'))
                self.adding_zone_popup.menuselect = self.addingzone
                self.adding_zone_popup.send(userid)
                if rush_punishment:
                    es.doblock("corelib/noisy_off")
            
ar = AntiRush()